package net.sf.sidaof.dao.hibernate;

import java.io.Serializable;

import org.hibernate.Session;
import org.hibernate.SessionFactory;

public class HibernateDaoImpl<K extends Serializable, E> extends
        AbstractHibernateDao<K, E> implements HibernateDao<K, E> {

    protected SessionFactory sessionFactory;

    /** Make a new instance, automatically determining the entity class. */
    public HibernateDaoImpl() {
        super();
    }

    /**
     * Make a new instance, specifying the entity class.
     * 
     * @param entityClass
     *            The entity class to manage.
     */
    public HibernateDaoImpl(Class<E> entityClass) {
        super(entityClass);
    }

    @Override
    public Session getSession() {
        return sessionFactory.getCurrentSession();
    }

    @Override
    public SessionFactory getSessionFactory() {
        return sessionFactory;
    }

    @Override
    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }
}
